<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\

if(!defined('ATSPHP')) {die('This file cannot be accessed directly.');}

class skin {
	var $filename;

	function __construct($filename) {
		$this->filename = $filename;
	}

	function make() {
		global $CONF, $TMPL;

		$file = "{$CONF['skins_path']}/{$TMPL['skin_name']}/{$this->filename}.html";
		$fh_skin = fopen($file, 'r');
		$skin = @fread($fh_skin, filesize($file));
		fclose($fh_skin);
		
		return $this->parse($skin);
	}

	function send_email($email) {
		global $CONF, $TMPL;

		$file = "{$CONF['skins_path']}/{$TMPL['skin_name']}/{$this->filename}.html";
		$fh_skin = fopen($file, 'r');
		$skin = @fread($fh_skin, filesize($file));
		fclose($fh_skin);

		$skin_array = explode("\n", $skin);

		$subject = array_shift($skin_array);
		$subject = str_replace('Subject: ', '', $subject);
		$body = implode("\n", $skin_array);

		$subject = $this->parse($subject);
		$body = $this->parse($body);

		$this->email($email, $subject, $body);
	}

	function email($to, $subject, $message, $html = 1) {
		$html = $html?"Content-Type: text/html\r\n":'';
		$html.= 'From: noreply@wtstats.info';
		if(!mail($to, $subject, $message, $html)) {
			echo 'Message could not be sent.'; exit();
		}
	}
	
	function parse($skin) {
		global $LNG, $TMPL;

		$skin = preg_replace_callback('/{\$lng->([a-zA-Z0-9_]+?)}/', create_function('$matches', 'global $LNG; return $LNG[$matches[1]];'),   $skin);
		$skin = preg_replace_callback('/{\$([a-zA-Z0-9_]+?)}/',      create_function('$matches', 'global $TMPL; return $TMPL[$matches[1]];'), $skin);

		return $skin;
	}
}
?>
