<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\

if(!defined('ATSPHP')) {die('This file cannot be accessed directly.');}

class search extends base {
	function __construct() {
		global $CONF, $FORM, $LNG, $TMPL;

		$TMPL['header'] = $LNG['search_header'];

		if (!$CONF['search']) {
			$this->error($LNG['search_off']);
		} elseif(!isset($FORM['q']) || !$FORM['q']) {
			$TMPL['content'] = '';
		} else {
			$this->process();
		}
	}

	function form() {
		global $TMPL;

		$TMPL['content'] = $this->do_skin('search_form');
	}

	function process() {
		global $CONF, $FORM, $LNG, $TMPL;
		
		$TMPL['query'] = strip_tags(urldecode($FORM['q']));
		$TMPL['words'] = mysql_real_escape_string($TMPL['query']);
		$words = explode(' ', $TMPL['words']);
		
		$TMPL['description'] = $TMPL['header'] = $TMPL['query'];
		$TMPL['keywd'] = str_replace(' ', ', ', $TMPL['query']);
		
		$words = array_filter($words, create_function('$word', 'return isset($word[2]);'));

		if(count($words) == 0) $this->error($LNG['search_error1']);
		
		if(isset($FORM['start'])) {
			$start = intval($FORM['start'])-1;
			if($start < 0) $start=0;
		} else {$start = 0;}

		$query = "(SELECT username, url, title, description, rank_cache FROM traffic_sites WHERE active = 1 AND (";
		$i = 0;
		foreach($words as $word) {
			if($i > 0) $query .= " OR ";
			$query .= "description LIKE '%{$word}%' OR title LIKE '%{$word}%'";
			$i++;
		}
		$query .= ")) UNION DISTINCT (SELECT username, url, title, description, rank_cache FROM traffic_details a JOIN traffic_sites b ON (a.id = b.id) WHERE active = 1 AND name = 'keyword' AND text = '{$TMPL['words']}' GROUP BY username)";
		
		$result = mysql_query($query); $TMPL['num_results'] = mysql_num_rows($result);
		$result = mysql_query($query." ORDER BY rank_cache LIMIT {$start}, 10;");

		$TMPL['results'] = '';
		$TMPL['rank'] = $start + 1;
		while (list($TMPL['username'], $TMPL['url'], $TMPL['title'], $TMPL['description']) = mysql_fetch_row($result)) {
			$TMPL['title'] = htmlspecialchars($TMPL['title'], ENT_QUOTES);
			$TMPL['description'] = htmlspecialchars($TMPL['description'], ENT_QUOTES);
			$TMPL['results'] .= $this->do_skin('search_result');
			$TMPL['rank']++;
		}
		
		if(!$TMPL['results']) $this->error('The are 0 results for: '.$TMPL['query']. '. Please do another search.');
		$prev_num = $start - 9;
		if ($prev_num < 1) $prev_num = 1;
		$next_num = $start + 11;
		
		if ($start >= 1) {
			$TMPL['previous'] = "<a style=\"color:#fff;\" href=\"{$TMPL['list_url']}/search/".urlencode($TMPL['query'])."/start/{$prev_num}\">{$LNG['search_prev']}</a>";
		} else {
			$TMPL['previous'] = "<span style=\"color:#000;\">{$LNG['search_prev']}</span>";
		}

		if ($next_num <= $TMPL['num_results']) {
			$TMPL['next'] = "<a style=\"color:#fff;\" href=\"{$TMPL['list_url']}/search/".urlencode($TMPL['query'])."/start/{$next_num}\">{$LNG['search_next']}</a>";
		} else {
			$TMPL['next'] =  "<span style=\"color:#000;\">{$LNG['search_next']}</span>";
		}

		$TMPL['displaying_results'] = sprintf($LNG['search_displaying_results'], ++$start, --$TMPL['rank'], $TMPL['num_results'], stripslashes($TMPL['query']));

		$TMPL['content'] = $this->do_skin('search_results');
	}
}
?>
